(ns com.aurellem.run.title
  (:use (com.aurellem.gb gb-driver vbm))
  (:use (com.aurellem.run util)))

(defn start [] [[] (root)])

(defn-memo title
  ([] (title (start)))
  ([script]
     (->> script
          (first-difference [] [:a] AF)
          (first-difference [] [:start] AF)
          (first-difference [] [:a] AF)
          (first-difference [] [:start] AF))))

(defn-memo oak
  ([] (oak (title)))
  ([script]
     (->> script
          (scroll-text 13))))

(defn-memo name-entry-rlm
  ([] (name-entry-rlm (oak)))
  ([script]
     (->> script
          (first-difference [] [:a] AF)
          (first-difference [] [:r] DE)
          (play-moves
           [[]
            [:r] [] [:r] [] [:r] [] [:r] []
            [:r] [] [:r] [] [:r] [] [:d] [:a]  
            [:l] [] [:l] [] [:l] [] [:l] []
            [:l] [] [:l] [:a] [] [:r] [:a]
            [:r] [] [:r] [] [:r] [] [:r] []
            [:r] [] [:d] [] [:d] [] [:d] [:a]]))))

(defn-memo name-entry-ash
  ([] (name-entry-ash (oak)))
  ([script]
     (->> script
          (first-difference [] [:d] AF)
          (first-difference [] [:d] AF)
          (first-difference [] [:a] AF))))
       
(defn-memo rival-name-entry-gary
  ([] (rival-name-entry-gary (name-entry-ash)))
  ([script]
     (->> script
          (scroll-text 5)
          (first-difference [] [:d] AF)
          (first-difference [] [:d] AF)
          (first-difference [] [:a] AF))))
  
(defn-memo rival-name-entry-blue
  ([] (rival-name-entry-blue (name-entry-ash)))
  ([script]
     (->> script
          (scroll-text 5)
          (first-difference [] [:d] AF)
          (first-difference [] [:a] AF))))

(defn-memo finish-title
  ([] (finish-title (rival-name-entry-blue)))
  ([script]
     (->> script
          (scroll-text 7))))
          
(def title-frames 2194)

(defn title-checkpoint! []
  (let [[moves state] (finish-title)]
    (assert (= title-frames (count moves)))
    [(write-moves! moves "title-checkpoint")
     (write-state! state "title-checkpoint")]))

(defn intro []
  [(read-moves "title-checkpoint")
   (read-state "title-checkpoint")])

(defn test-intro []
  (play-vbm (moves-filename "title-checkpoint")))

;; TODO might be able to glue these together more elegantly with monads

